#include "cdreader.h"

#ifdef _WINDOWS

#endif

//  about.c
//  has the config, about, and test functions and related structs

//  lots of this code was taken from PEOPS.  THANK YOU!!!!

const  unsigned char version	= 1;	  // do not touch - library for PSEmu 1.x

#define REVISION  1
#define BUILD 6

#ifdef _DEBUG
#ifdef SUPER_DEBUG
static char *libraryName		= "Mooby cd disk image super debug driver";
#else
static char *libraryName		= "Mooby cd disk image debug driver";
#endif
#else
static char *libraryName		= "Mooby cd disk image driver";
#endif

static char *PluginAuthor		= "Mooby";

static FPSEWin32About aboutMooby = {FPSE_CDROM, 
   BUILD, 
   REVISION, 
   FPSE_OK, 
   "mooby", 
#ifdef _DEBUG
#ifdef SUPER_DEBUG
   "Mooby cd disk image super debug driver",
#else
   "Mooby cd disk image debug driver",
#endif
#else
   "Mooby cd disk image driver",
#endif
   "moo"};



// lots of this code was swiped from PEOPS.  thank you =)
char * CALLBACK PSEgetLibName(void)
{
 return libraryName;
}

unsigned long CALLBACK PSEgetLibType(void)
{
 return	PSE_LT_CDR;
}

unsigned long CALLBACK PSEgetLibVersion(void)
{
 return version<<16|REVISION<<8|BUILD;
}

// FPSE about - just return the struct
void CD_About(UINT32 *par) 
{   
   memcpy(par, &aboutMooby, sizeof(FPSEWin32About));
}


// psemu about.  opens the about box
void CALLBACK CDRabout(void)
{
#ifdef _WINDOWS
   MessageBox(NULL,libraryName,"Moo",MB_OK|MB_SETFOREGROUND);
#endif
}
