#include "cdreader.h"


//  config.c
//  has the config and test functions and related structs

// hijack this to do compression =)
long configure(void)
{
#ifdef _WINDOWS


   
   rc = MessageBox(NULL,"There's nothing to configure.\nHit Yes to compress an image.\nHit No to decompress an image.\nHit cancel to go to the menu.","CDRMooby",MB_YESNOCANCEL|MB_SETFOREGROUND);

   if (rc == IDCANCEL)
   {
      return 0;
   }

   if (rc == IDYES)
   {
OPENFILENAME	  ofn;

	 char 	 szFileTitle[_MAX_FNAME + _MAX_EXT], 
							szFile[_MAX_PATH];

    // add new file types here!!
    char 	 szFilter[] = "All files (*.*)\0*.*\0" \
								  "Bin file (*.bin)\0*.bin\0" \
                          "Iso file (*.iso)\0*.iso\0" \
                          "Img file (*.img)\0*.img\0" \
                          "\0";


    char   currentDir[_MAX_PATH];
   _getcwd( currentDir, _MAX_PATH );

	szFile[0] = '\0';
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);

      // fpse needs this handle or else the open dialog won't stay open
   if (g != NULL)
   {
	   ofn.hwndOwner = g->HWnd;
   }
   else
   {
	   ofn.hwndOwner = NULL;
   }
   ofn.lpstrTitle = "Choose a file to compress\0";
	ofn.lpstrFilter = szFilter;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = _MAX_PATH;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = _MAX_FNAME + _MAX_EXT;
	ofn.lpstrInitialDir = NULL;	  /* use current directory */
	ofn.lpstrDefExt = NULL;		  /* default file extension */
										  
	GetOpenFileName(&ofn);
	lstrcat(szFile,"\0");	/* make sure it's null terminated */
   
   if (szFile[0] == '\0')
   {
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "zippin toast %s\n",szFile);
   fclose(log);
#endif

      MessageBox(NULL,"No file selected","CDRMooby exiting",MB_OK|MB_SETFOREGROUND);
   _chdir(currentDir);
      return 0;
   }

#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "zippin %s\n",szFile);
   fclose(log);
#endif



   {
      char bzname[512];
      FILE* theImage;
      FILE* outputFile;
      FILE* indexFile;
      long end;
      theImage = fopen(szFile, "rb");
      if (!theImage)
      {
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "zippin toast1 %s\n",szFile);
   fclose(log);
#endif

         MessageBox(NULL,"Can't open the output file","CDRMooby",MB_OK|MB_SETFOREGROUND);
         _chdir(currentDir);

         return 0;
      }

      rc = fseek(theImage, 0, SEEK_END);

#ifdef MOOBY_DEBUG
      log = fopen(LOGFILE,"a");
      fprintf(log, " openiso1 rc %d\n", rc);
      fclose(log);
#endif   

      end = ftell(theImage);

      fseek(theImage,0,SEEK_SET);
      lstrcat(szFile,".bz\0");
      strcpy(bzname,szFile);

      outputFile = fopen(szFile, "wb");

      lstrcat(szFile,".index\0");

      indexFile = fopen(szFile, "wb");

      if (!indexFile || !outputFile)
      {
#ifdef MOOBY_DEBUG
         log = fopen(LOGFILE,"a");
         fprintf(log, "zippin toast2 %s\n",szFile);
         fclose(log);
#endif

         MessageBox(NULL,"Can't open output files","CDRMooby",MB_OK|MB_SETFOREGROUND);
         _chdir(currentDir);
         return 0;
     }
     end = 0;

     MessageBox(NULL,"Hit OK.  This is going to take a LONG time.","CDRMooby",MB_OK|MB_SETFOREGROUND);

     while (!feof(theImage))
     {
        size_t written;
        char inputBuffer[2352 * BZIP_BUFFER_SECTORS];
        char outputBuffer[2352 * (BZIP_BUFFER_SECTORS + 1)];
        unsigned int destLen = 2352 * (BZIP_BUFFER_SECTORS + 1);
        unsigned int inputLen = fread(inputBuffer,  1, 2352*BZIP_BUFFER_SECTORS,theImage);

        if (BZ2_bzBuffToBuffCompress( outputBuffer,
                                      &destLen,
                                      inputBuffer,
                                      inputLen,
                                      1,
                                      0,
                                      30 ) != BZ_OK)
         {
            MessageBox(NULL,"error zipping - can't continue","CDRMooby",MB_OK|MB_SETFOREGROUND);
            fclose(theImage);
            fclose(outputFile);
            fclose(indexFile);
            unlink(szFile);
            unlink(bzname);
            _chdir(currentDir);
            return 0;            

         }

         written = fwrite(outputBuffer, sizeof(char), destLen, outputFile);
         fwrite(&end,sizeof(end),1,indexFile);
         end += written;
         if ( (destLen != written) || ferror(outputFile) ||
               ferror(indexFile) )
         {
            MessageBox(NULL,"error writing to files - can't continue","CDRMooby",MB_OK|MB_SETFOREGROUND);
            fclose(theImage);
            fclose(outputFile);
            fclose(indexFile);
            unlink(szFile);
            unlink(bzname);
            _chdir(currentDir);
            return 0;            
         }
      }

      fwrite(&end,1,sizeof(end),indexFile);
      fclose(theImage);
      fclose(outputFile);
      fclose(indexFile);
   }
   MessageBox(NULL,"all done =)\nRemember to delete the original image.","CDRMooby",MB_OK|MB_SETFOREGROUND);
   _chdir(currentDir);
}
   else if (rc == IDNO)
   {
   OPENFILENAME	  ofn;

	 char 	 szFileTitle[_MAX_FNAME + _MAX_EXT], 
							szFile[_MAX_PATH];

    // add new file types here!!
    char 	 szFilter[] = "All files (*.*)\0*.*\0" \
								  "Bin file (*.bin)\0*.bin\0" \
                          "Iso file (*.iso)\0*.iso\0" \
                          "Img file (*.img)\0*.img\0" \
                          "\0";


    char   currentDir[_MAX_PATH];
   _getcwd( currentDir, _MAX_PATH );

	szFile[0] = '\0';
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);

      // fpse needs this handle or else the open dialog won't stay open
   if (g != NULL)
   {
	   ofn.hwndOwner = g->HWnd;
   }
   else
   {
	   ofn.hwndOwner = NULL;
   }
   ofn.lpstrTitle = "Choose a file to decompress\0";
	ofn.lpstrFilter = szFilter;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = _MAX_PATH;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = _MAX_FNAME + _MAX_EXT;
	ofn.lpstrInitialDir = NULL;	  /* use current directory */
	ofn.lpstrDefExt = NULL;		  /* default file extension */
										  
	GetOpenFileName(&ofn);
	lstrcat(szFile,"\0");	/* make sure it's null terminated */
   
   if (szFile[0] == '\0')
   {
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "zippin toast %s\n",szFile);
   fclose(log);
#endif

      MessageBox(NULL,"No file selected","CDRMooby exiting",MB_OK|MB_SETFOREGROUND);
   _chdir(currentDir);
      return 0;
   }

#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "unzippin %s\n",szFile);
   fclose(log);
#endif

   if (!strstr(szFile,".bz.index") && !(strstr(szFile,".bz")))
   {
      MessageBox(NULL,"You didn't choose a correct file","CDRMooby",MB_OK|MB_SETFOREGROUND);
   _chdir(currentDir);
      return 0; 
   }
   


   {
      char bzname[512];
      char indexname[512];
      char imagename[512];
      FILE* theImage;
      FILE* bzFile;
      FILE* indexFile;
      long end,start;

      if (strstr(szFile, ".bz.index"))
      {
         char * c = strstr(szFile,".index");
         strcpy(indexname,szFile);
         *c = '\0';
         strcpy(bzname,szFile);
      }
      else
      {
         strcpy(bzname,szFile);
         strcpy(indexname,szFile);
         lstrcat(indexname,".index\0");
      }
      strcpy(imagename,bzname);
      *(strstr(imagename,".bz")) = '\0';

      theImage = fopen(imagename, "wb");
      if (!theImage)
      {
#ifdef MOOBY_DEBUG
         log = fopen(LOGFILE,"a");
         fprintf(log, "unzippin toast1 %s\n",szFile);
         fclose(log);
#endif

         MessageBox(NULL,"Can't open the output file","CDRMooby",MB_OK|MB_SETFOREGROUND);
         _chdir(currentDir);
         return 0;
      }

      indexFile = fopen(indexname,"rb");
      bzFile = fopen(bzname,"rb");
      
#ifdef MOOBY_DEBUG
      log = fopen(LOGFILE,"a");
      fprintf(log, " openiso1 rc %d\n", rc);
      fclose(log);
#endif   

     if (!indexFile || !bzFile)
     {
#ifdef MOOBY_DEBUG
         log = fopen(LOGFILE,"a");
         fprintf(log, "zippin toast2 %s\n",szFile);
         fclose(log);
#endif

         MessageBox(NULL,"Can't open input files","CDRMooby",MB_OK|MB_SETFOREGROUND);
         _chdir(currentDir);
         return 0;
     }
     end = 0;
     start = 0;

     MessageBox(NULL,"Hit OK and be prepared to wait a LONG while","CDRMooby",MB_OK);

     fread(&end,1,sizeof(end),indexFile);

     fread(&end,1,sizeof(end),indexFile);
     while (!feof(indexFile))
     {
         unsigned int written;
         char inputBuffer[2352 * (BZIP_BUFFER_SECTORS + 1)];
         char outputBuffer[2352 * (BZIP_BUFFER_SECTORS + 1)];
         unsigned int destLen = 2352 * (BZIP_BUFFER_SECTORS + 1);
         unsigned int inputLen;

         
         inputLen = end - start;

         fseek(bzFile,start,SEEK_SET);
         fread(inputBuffer,sizeof(char),inputLen,bzFile);

         if ((rc = BZ2_bzBuffToBuffDecompress( outputBuffer,
                                   &destLen,
                                   inputBuffer,
                                   inputLen,
                                   0,
                                   0 ) )!= BZ_OK)
         {
            printf("rc = %d\n",rc);
            MessageBox(NULL,"error zipping","CDRMooby exiting",MB_OK|MB_SETFOREGROUND);
            fclose(theImage);
            fclose(bzFile);
            fclose(indexFile);
            unlink(imagename);
            _chdir(currentDir);
            return 0;            

         }

         written = fwrite(outputBuffer, sizeof(char), destLen, theImage);

         if ( (destLen != written) || ferror(indexFile) )
         {
            MessageBox(NULL,"error writing to files","CDRMooby exiting",MB_OK|MB_SETFOREGROUND);
            fclose(theImage);
            fclose(bzFile);
            fclose(indexFile);
            unlink(imagename);
            _chdir(currentDir);
            return 0;            
         }

         start = end;

         fread(&end,1,sizeof(end),indexFile);
     }
               
     fclose(theImage);
     fclose(bzFile);
     fclose(indexFile);
   }
            
   MessageBox(NULL,"all done =)\nRemember to delete the original image.","CDRMooby",MB_OK|MB_SETFOREGROUND);
   _chdir(currentDir);

   }
#endif 
   return 0;
}

// FPSE config - nothing to configure here
int CD_Configure(UINT32 *par) 
{
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "configure\n");
   fclose(log);
#endif
   configure();
   return 0;
}


// psemu config - nothing again.
long CALLBACK CDRconfigure(void)
{
   
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "configure\n");
   fclose(log);
#endif

   configure();
   return 0;
}


// psemu test - ok no matter what ;)
long CALLBACK CDRtest(void)
{


    
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "test\n");
   fclose(log);
#endif

#ifdef _WINDOWS
    MessageBox(NULL,"It damn well better work.","CDRMooby",MB_OK|MB_SETFOREGROUND);
#endif
   return 0;
}
